#define MAXARGS 20

#include <stdio.h>

void main(int argc, char** argv) {

    char *args[MAXARGS];
    int i;

    if (argc < 4) {
	printf("\r\n");
	printf("Usage: cgiexe cgidir execbin1 execbin2 [querystrings]*\r\n");
	exit(1);
    }

    if (argc > MAXARGS + 4) {
	printf("\r\n");
	printf("maximum number of arguments exceeded\r\n");
	exit(2);
    }

    chdir(argv[1]);

/* Used for perlexe, not normally needed for Unix */
    if (strcmp(argv[3],"--none--") != 0) {
	args[0] = argv[3];
	args[1] = argv[2];
	for (i = 4; i < argc; i++) {
	  args[i - 2] = argv[i];
	}
        args[i-2] = NULL;
        execv(args);
    }

    args[0] = argv[2];
    for (i = 4; i < argc; i++) {
	args[i - 3] = argv[i];
    }
    args[i-3] = NULL;

    execv(args[0],args);
}

