/*
 * @(#)ContentServlet.java	1.3 98/02/25
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

package jsp.beans;

public class ColorGameBean {

    private String background = "yellow";
    private String foreground = "red";
    private String hint = "no";
    private int attempts = 0;
    private boolean tookHints = false;

    public void setColor2(String x) {

	if (! x.equals(foreground)) {
	    if (x.equalsIgnoreCase("black") ||
		x.equalsIgnoreCase("cyan"))
		background = x;
	}
    }

    public void setColor1(String x) {
	if (! x.equals(background)) {
	    if (x.equalsIgnoreCase("black") ||
		x.equalsIgnoreCase("cyan")) {
		foreground = x;
	    }
	}
	attempts++;
    }

    public void setAction(String x) {
	if (!tookHints)
	    tookHints = x.equalsIgnoreCase("hint");
	hint = x;
    }

    public String getColor2() {
	return background;
    }

    public String getColor1() {
	return foreground;
    }

    public int getAttempts() {
	return attempts;
    }

    public boolean getHint() {
	return hint.equalsIgnoreCase("Hint");
    }

    public boolean getSuccess() {
	if (background.equalsIgnoreCase("black") ||
	    background.equalsIgnoreCase("cyan")) {
	
	    if (foreground.equalsIgnoreCase("black") ||
		foreground.equalsIgnoreCase("cyan"))
		return true;
	    else
		return false;
	}

	return false;
    }

    public boolean gotHints() {
	return tookHints;
    }

    public void reset() {
	foreground = "red";
	background = "yellow";
    }
}
